package testw32apianno;
import utildll.*;
public class TestW32API1 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API1();
	}
	
	TestW32API1() {
		int intRtnVal;
		boolean blRtnVal;

		intRtnVal = JInvoker.callIntProc("GetTickCount", "kernel32", null);
		
		System.out.println("GetTickCount rtn: " + Integer.toString(intRtnVal));

		
		Arg_GetDriveType agdt = new Arg_GetDriveType("C:\\");
		
		intRtnVal = JInvoker.callIntProc("GetDriveType", "kernel32", agdt);
		
		System.out.println("GetDriveType rtn: " + Integer.toString(intRtnVal));

	
		Struct_POINT sp = new Struct_POINT();
		Arg_GetCursorPos agcp = new Arg_GetCursorPos(sp);
		
		blRtnVal = JInvoker.callBooleanProc("GetCursorPos", "user32", agcp);
		
		System.out.println("GetCursorPos rtn: " + Boolean.toString(blRtnVal)
			 + "," + Integer.toString(sp.x) 
			 + "," + Integer.toString(sp.y));


		Arg_SetCursorPos ascp = new Arg_SetCursorPos(50, 300);
		
		blRtnVal = JInvoker.callBooleanProc("SetCursorPos", "user32", ascp);
		
		System.out.println("SetCursorPos rtn: " + Boolean.toString(blRtnVal));


		Arg_GetCurrentDirectory agcd = new Arg_GetCurrentDirectory(256);

		intRtnVal = JInvoker.callIntProc("GetCurrentDirectory", "kernel32", agcd);

		System.out.println("GetCurrentDirectory rtn: " + Integer.toString(intRtnVal)
				+ " LastError: " + Integer.toString(agcd.getLastError())
				+ " lpszCurDir: " + agcd.getCurDir());

		
		String strCurDir = agcd.getCurDir() + "\\";
		Arg_GetPrivateProfileInt agppi = new Arg_GetPrivateProfileInt("sec", "key", -1,
				strCurDir + "test.ini");
		
		intRtnVal = JInvoker.callIntProc("GetPrivateProfileInt", "kernel32", agppi);
		
		System.out.println("GetPrivateProfileInt rtn: " + Integer.toString(intRtnVal));

		
		Arg_GetPrivateProfileString agpps = new Arg_GetPrivateProfileString("sec", "key2",
				"Default", 50, strCurDir + "test.ini");
	
		intRtnVal = JInvoker.callIntProc("GetPrivateProfileString", "kernel32", agpps);
	
		System.out.println("GetPrivateProfileString rtn: " + Integer.toString(intRtnVal)
				+ " lpReturnedString: " + agpps.getReturnedString());

		
		Arg_GetPrivateProfileSection agppsc = new Arg_GetPrivateProfileSection("sec",
				50, strCurDir + "test.ini");
	
		intRtnVal = JInvoker.callIntProc("GetPrivateProfileSection", "kernel32", agppsc);
	
		System.out.println("GetPrivateProfileSection rtn: " + Integer.toString(intRtnVal)
				+ " lpReturnedString: " + agppsc.getReturnedString());
		
	
		Arg_wsprintf awpf = new Arg_wsprintf(50, "%d %#x %c %hs %ls", 123, 10, 'c', "abc", "");
		
		intRtnVal = JInvoker.callIntProc("wsprintf", "user32", awpf);
		
		System.out.println("wsprintf rtn: " + Integer.toString(intRtnVal) + "," + awpf.getBuffer());

	}
	
	/*
	UINT GetDriveType(
	  LPCTSTR lpRootPathName   // [gfBNg
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetDriveType {
		private @_Const String lpszRootPathName;
		
		Arg_GetDriveType(String lpszRootPathName){
			this.lpszRootPathName = lpszRootPathName;
		}
	}
	
	/*
	typedef struct tagPOINT {
	   LONG x;
	   LONG y;
	} POINT;
	 */
	class Struct_POINT {
		int x;
		int y;
	}
	
	/*
	BOOL GetCursorPos(
	  LPPOINT lpPoint   // J[\̈ʒu
	);	 
	 */
	class Arg_GetCursorPos {
		private Struct_POINT lpPoint;
		
		Arg_GetCursorPos(Struct_POINT lpPoint){
			this.lpPoint = lpPoint;
		}
	}

	/*
	BOOL SetCursorPos(
	  int X,  // ʒu
	  int Y   // ʒu
	);
	 */
	class Arg_SetCursorPos {
		private int x;
		private int y;
		
		Arg_SetCursorPos(int x, int y){
			this.x = x;
			this.y = y;
		}
	}

	/*
	DWORD GetCurrentDirectory(
	  DWORD nBufferLength,  // fBNgobt@̃TCY
	  LPTSTR lpBuffer       // fBNgobt@
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetCurrentDirectory {
		private int _LastError;
		
		private int dwcCurDir;
		private String lpszCurDir;
		
		Arg_GetCurrentDirectory(int dwcCurDir) {
			this.dwcCurDir = dwcCurDir;
			StringBuffer sb = new StringBuffer(dwcCurDir);
			for (int i = 0; i < dwcCurDir; i++) {
				sb.append(' ');
			}
			this.lpszCurDir = sb.toString();
		}
		String getCurDir() {return lpszCurDir;}
		int getLastError() {return _LastError;}
	}

	/*
	UINT GetPrivateProfileInt(
	  LPCTSTR lpAppName,  // ZNV
	  LPCTSTR lpKeyName,  // L[
	  INT nDefault,       // L[ȂꍇɕԂׂl
	  LPCTSTR lpFileName  // .ini t@C̖O
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetPrivateProfileInt {
		private @_Const String lpszSec;
		private @_Const String lpszKey;
		private int dwDefault;
		private @_Const String lpszIniFileName;
		
		Arg_GetPrivateProfileInt(String lpszSec, String lpszKey, 
				int dwDefault, String lpszIniFileName) {
			this.lpszSec = lpszSec;
			this.lpszKey = lpszKey;
			this.dwDefault = dwDefault;
			this.lpszIniFileName = lpszIniFileName;
		}
	}
	
	/*
	DWORD GetPrivateProfileString(
	  LPCTSTR lpAppName,        // ZNV
	  LPCTSTR lpKeyName,        // L[
	  LPCTSTR lpDefault,        // ̕
	  LPTSTR lpReturnedString,  // 񂪊i[obt@
	  DWORD nSize,              // obt@̃TCY
	  LPCTSTR lpFileName        // .ini t@C̖O
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetPrivateProfileString {
		private @_Const String lpAppName;
		private @_Const String lpKeyName;
		private @_Const String lpDefault;
		private String lpReturnedString;
		private int nSize;
		private @_Const String lpFileName;
		
		Arg_GetPrivateProfileString(String lpAppName, String lpKeyName, 
				String lpDefault, int nSize, String lpFileName) {
			this.lpAppName = lpAppName;
			this.lpKeyName = lpKeyName;
			this.lpDefault = lpDefault;
			StringBuffer sb = new StringBuffer(nSize);
			for (int i = 0; i < nSize; i++) {
				sb.append(' ');
			}
			this.lpReturnedString = sb.toString();
			this.nSize = nSize;
			this.lpFileName = lpFileName;
		}
		String getReturnedString() {return lpReturnedString;}
	}

	/*
	DWORD GetPrivateProfileSection(
	  LPCTSTR lpAppName,        // ZNV
	  LPTSTR lpReturnedString,  // 񂪊i[obt@
	  DWORD nSize,              // obt@̃TCY
	  LPCTSTR lpFileName        // .ini t@C̖O
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetPrivateProfileSection {
		private @_Const String lpAppName;
		private @_BStr String lpReturnedString;
		private int nSize;
		private @_Const String lpFileName;
		
		Arg_GetPrivateProfileSection(String lpAppName, int nSize, String lpFileName) {
			this.lpAppName = lpAppName;
			StringBuffer sb = new StringBuffer(nSize);
			for (int i = 0; i < nSize; i++) {
				sb.append(' ');
			}
			this.lpReturnedString = sb.toString();
			this.nSize = nSize;
			this.lpFileName = lpFileName;
		}
		String getReturnedString() {return lpReturnedString;}
	}
	
	/*
	int wsprintf(
	  LPTSTR lpOut,    // o̓obt@
	  LPCTSTR lpFmt,   // 䕶
	  ...              // IvV̈
	);
	 */
	@_CharSet(CHARSET) @_Call(Arg.CDECL)
	class Arg_wsprintf {
		private String lpBuffer;
		private @_Const String lpszFormatString;
		private int d1;
		private int d2;
		private char d3;
		private @_Const @_Ansi String d4;
		private @_Const @_Unicode String d5;
		
		Arg_wsprintf(int intLen, String lpszFormatString,
				int d1, int d2, char d3, String d4, String d5) {
			StringBuffer sb = new StringBuffer(intLen);
			for (int i = 0; i < intLen; i++) {
				sb.append(' ');
			}
			this.lpBuffer = sb.toString();
			this.lpszFormatString = lpszFormatString;
			this.d1 = d1;
			this.d2 = d2;
			this.d3 = d3;
			this.d4 = d4;
			this.d5 = d5;
		}
		String getBuffer() {return lpBuffer;}
	}
	
}

