package testw32apianno;
import utildll.*;
public class TestW32API2 {
	final static int CHARSET = Arg.UNICODE;
	//final static int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API2();
	}
	
	TestW32API2() {
		int intRtnVal;
		boolean blRtnVal;

		Arg_GetCurrentDirectory agcd = new Arg_GetCurrentDirectory(256);

		intRtnVal = JInvoker.callIntProc("GetCurrentDirectory", "kernel32", agcd);

		System.out.println("GetCurrentDirectory rtn: " + Integer.toString(intRtnVal)
				+ " LastError: " + Integer.toString(agcd.getLastError())
				+ " lpszCurDir: " + agcd.getCurDir());

		
		String strCurDir = agcd.getCurDir() + "\\";
		Struct_SHFILEOPSTRUCT ssfo = new Struct_SHFILEOPSTRUCT();
		ssfo.hwnd = 0;
		ssfo.wFunc = Shell_h.FO_COPY;
		ssfo.pFrom = strCurDir + "test.bmp" + "\u0000";
		ssfo.pTo = strCurDir + "testcopy.bmp" + "\u0000";
		ssfo.fFlags = Shell_h.FOF_SIMPLEPROGRESS;
		ssfo.fAnyOperationsAborted = false;
		ssfo.hNameMappings = null;
		ssfo.lpszProgressTitle = "t@CRs[Ă܂";
		
		Arg_SHFileOperation asfo = new Arg_SHFileOperation(ssfo);

		intRtnVal = JInvoker.callIntProc("SHFileOperation", "shell32.dll", asfo);

		System.out.println("SHFileOperation rtn: " + Integer.toString(intRtnVal)
				+ " fAnyOperationsAborted: " + Boolean.toString(ssfo.fAnyOperationsAborted));

		
		Struct_OSVERSIONINFO sovi = new Struct_OSVERSIONINFO();
		Arg_GetVersionEx agve = new Arg_GetVersionEx(sovi);
		
		blRtnVal = JInvoker.callBooleanProc("GetVersionEx", "kernel32.dll", agve);

		System.out.println("GetVersionEx rtn: " + Boolean.toString(blRtnVal)
				+ " dwMajorVersion:" + Integer.toString(sovi.dwMajorVersion)
				+ " dwMinorVersion:" + Integer.toString(sovi.dwMinorVersion)
				+ " dwBuildNumber:" + Integer.toString(sovi.dwBuildNumber)
				+ " dwPlatformId:" + Integer.toString(sovi.dwPlatformId));
		if (Arg.UNICODE  == CHARSET)
			System.out.println("szCSDVersionW:" + new String(sovi.szCSDVersionW));
		else
			System.out.println("szCSDVersionA:" + new String(sovi.szCSDVersionA));
	

		Arg_CopyFile acf = new Arg_CopyFile(strCurDir + "test.bmp",
				strCurDir + "testcopy.bmp", true);
			
		blRtnVal = JInvoker.callBooleanProc("CopyFile", "kernel32.dll", acf);
		
		System.out.println("CopyFile rtn: " + Boolean.toString(blRtnVal)
				+ " LastError: " + Integer.toString(acf.getLastError()));

		
		Arg_GetLogicalDrives agld = new Arg_GetLogicalDrives();

		intRtnVal = JInvoker.callIntProc("GetLogicalDrives", "kernel32", agld);

		System.out.println("GetLogicalDrives rtn: " + Integer.toHexString(intRtnVal)
			+ " LastError: " + Integer.toString(agld.getLastError()));

	
	}
	
	/*
	DWORD GetCurrentDirectory(
	  DWORD nBufferLength,  // fBNgobt@̃TCY
	  LPTSTR lpBuffer       // fBNgobt@
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetCurrentDirectory {
		private int _LastError;
		
		private int dwcCurDir;
		private String lpszCurDir;
		
		Arg_GetCurrentDirectory(int dwcCurDir) {
			this.dwcCurDir = dwcCurDir;
			StringBuffer sb = new StringBuffer(dwcCurDir);
			for (int i = 0; i < dwcCurDir; i++) {
				sb.append(' ');
			}
			this.lpszCurDir = sb.toString();
		}
		String getCurDir() {return lpszCurDir;}
		int getLastError() {return _LastError;}
	}
	
	class Shell_h {
		static final int FO_COPY = 2;
		static final int FOF_SIMPLEPROGRESS = 0x100;
	}

	/*
	typedef struct _SHFILEOPSTRUCT{ 
	    HWND hwnd; 
	    UINT wFunc; 
	    LPCTSTR pFrom; 
	    LPCTSTR pTo; 
	    FILEOP_FLAGS fFlags; 
	    BOOL fAnyOperationsAborted; 
	    LPVOID hNameMappings; 
	    LPCTSTR lpszProgressTitle; 
	} SHFILEOPSTRUCT
	 */
	@_CharSet(CHARSET) //@_Pack(1) x64̏ꍇsv
	class Struct_SHFILEOPSTRUCT {
		@_Const long hwnd;
		@_Const int wFunc;
		@_Const @_BStr String pFrom;
		@_Const @_BStr String pTo;
		@_Const short fFlags;
		boolean fAnyOperationsAborted;
		@_Const Object hNameMappings;
		@_Const String lpszProgressTitle;
	}
	
	/*
	SHSTDAPI_(int) SHFileOperationA(__inout LPSHFILEOPSTRUCTA lpFileOp);
	SHSTDAPI_(int) SHFileOperationW(__inout LPSHFILEOPSTRUCTW lpFileOp);
	 */
	@_CharSet(CHARSET)
	class Arg_SHFileOperation {
		private Struct_SHFILEOPSTRUCT lpFileOp;
		
		Arg_SHFileOperation(Struct_SHFILEOPSTRUCT lpFileOp) {
			this.lpFileOp = lpFileOp;
		}
	}
	
	/*
	typedef struct _OSVERSIONINFO{ 
	  DWORD dwOSVersionInfoSize; 
	  DWORD dwMajorVersion; 
	  DWORD dwMinorVersion; 
	  DWORD dwBuildNumber; 
	  DWORD dwPlatformId; 
	  TCHAR szCSDVersion[ 128 ]; 
	} OSVERSIONINFO;
	 */
	@_MemSize(2048) @_CharSet(CHARSET)
	class Struct_OSVERSIONINFO { 
		int dwOSVersionInfoSize; 
		int dwMajorVersion; 
		int dwMinorVersion; 
		int dwBuildNumber; 
		int dwPlatformId; 
		//union start
		@_Fixed char szCSDVersionW[]; 
		@_Fixed byte szCSDVersionA[]; 
		//union end
	} 

	/*
	BOOL GetVersionEx(
	  LPOSVERSIONINFO lpVersionInfo // o[W
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetVersionEx {
		private Struct_OSVERSIONINFO lpVersionInfo;
		
		Arg_GetVersionEx(Struct_OSVERSIONINFO lpVersionInfo) {
			this.lpVersionInfo = lpVersionInfo;
			if (Arg.UNICODE  == CHARSET) {
				lpVersionInfo.dwOSVersionInfoSize = 4 * 5 + 2 * 128;
				lpVersionInfo.szCSDVersionW = new char[128];
				lpVersionInfo.szCSDVersionA = null;
			}
			else {
				lpVersionInfo.dwOSVersionInfoSize = 4 * 5 + 1 * 128;
				lpVersionInfo.szCSDVersionW = null;
				lpVersionInfo.szCSDVersionA = new byte[128];
			}
		}
	}
	
	/*
	BOOL CopyFile(
	  LPCTSTR lpExistingFileName, // ̃t@C̖O
	  LPCTSTR lpNewFileName,      // Vt@C̖O
	  BOOL bFailIfExists          // t@C݂ꍇ̓
	);
	 */
	@_CharSet(CHARSET)
	class Arg_CopyFile {
		private int _LastError;

		private @_Const String lpszExistingFile;
		private @_Const String lpszNewFile;
		private boolean bFailIfExists;
		
		Arg_CopyFile(String lpszExistingFile, String lpszNewFile, boolean bFailIfExists) {
			this.lpszExistingFile = lpszExistingFile;
			this.lpszNewFile = lpszNewFile;
			this.bFailIfExists = bFailIfExists;
		}
		int getLastError() {return _LastError;}
	}

	/*
	DWORD GetLogicalDrives(VOID);
	 */
	class Arg_GetLogicalDrives {
		private int _LastError;
		int getLastError() {return _LastError;}
	}

}
