package testw32apianno;
import utildll.*;
public class TestW32API5 {
	final static int CHARSET = Arg.UNICODE;
	//final static int CHARSET = Arg.ANSI;//s

	public static void main(String[] args) {
		new TestW32API5();
	}
	
	TestW32API5() {
		int intRtnVal;
		
		Struct_CLSID scid = new Struct_CLSID(0x2df01, 0x0, 0x0,
				0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x46);
		
		Struct_OLESTR sos = new Struct_OLESTR();
		
		Arg_StringFromCLSID asfc = new Arg_StringFromCLSID(scid, sos);

		intRtnVal = JInvoker.callIntProc("StringFromCLSID", "ole32", asfc);

		System.out.println("StringFromCLSID rtn: " + Integer.toString(intRtnVal));
		System.out.println("ppsz: " + sos.ppsz);

		Struct_OLESTR sos2 = new Struct_OLESTR();
		
		Arg_ProgIDFromCLSID apfc = new Arg_ProgIDFromCLSID(scid, sos2);
		
		intRtnVal = JInvoker.callIntProc("ProgIDFromCLSID", "ole32", apfc);

		System.out.println("ProgIDFromCLSID rtn: " + Integer.toString(intRtnVal));
		System.out.println("ppsz: " + sos2.ppsz);

	}
	
	/*
	WINOLEAPI StringFromCLSID(
	  REFCLSID rclsid, //CLSID to be converted
	  LPOLESTR * ppsz  //Address of output variable that receives a 
	                   // pointer to the resulting string
	);
	 */
	@_CharSet(CHARSET)
	class Arg_StringFromCLSID {
		private @_Const Struct_CLSID rclsid;
		private Struct_OLESTR olestr;
		
		Arg_StringFromCLSID(Struct_CLSID rclsid, Struct_OLESTR olestr) {
			this.rclsid = rclsid;
			this.olestr = olestr;
		}
	}

	/*
	typedef struct _GUID {
	    unsigned long  Data1;
	    unsigned short Data2;
	    unsigned short Data3;
	    unsigned char  Data4[ 8 ];
	} GUID;
	typedef GUID CLSID;
	 */
	class Struct_CLSID {
		int Data1;
		short Data2;
		short Data3;
		@_Fixed byte[] Data4 = new byte[8];
		
		Struct_CLSID(int Data1, int Data2, int Data3,
				int Data40, int Data41, int Data42, int Data43,
				int Data44, int Data45, int Data46, int Data47) {
			this.Data1 = Data1; this.Data2 = (short)Data2; this.Data3 = (short)Data3;
			this.Data4[0] = (byte)Data40; this.Data4[1] = (byte)Data41;
			this.Data4[2] = (byte)Data42; this.Data4[3] = (byte)Data43;
			this.Data4[4] = (byte)Data44; this.Data4[5] = (byte)Data45;
			this.Data4[6] = (byte)Data46; this.Data4[7] = (byte)Data47;
		}
	}
	
	@_CharSet(CHARSET)
	class Struct_OLESTR {
		@_AutoMem String ppsz;
	}

	/*
	WINOLEAPI ProgIDFromCLSID(
	  REFCLSID clsid,  //CLSID for which the ProgID is requested
	  LPOLESTR * lplpszProgID
	                   //Address of output variable that receives a 
	                   // pointer to the requested ProgID string
	);
	 */
	class Arg_ProgIDFromCLSID {
		private @_Const Struct_CLSID rclsid;
		private Struct_OLESTR olestr;

		Arg_ProgIDFromCLSID(Struct_CLSID rclsid, Struct_OLESTR olestr) {
			this.rclsid = rclsid;
			this.olestr = olestr;
		}
	}
}

