package testw32apianno;
import utildll.*;
public class TestW32API7 {
	public static void main(String[] args) {
		new TestW32API7();
	}
	
	TestW32API7() {
		int[] intBase = {5, 2, 4, 1, 3};
		
		Arg_QSort aqs = new Arg_QSort(intBase, intBase.length, 4, new Func_QSortCompareProc());
		
		JInvoker.callVoidProc("qsort", "msvcrt", aqs);
		
		System.out.println("qsort LastError: " + Integer.toString(aqs.getLastError()));
		
		for (int i = 0; i < intBase.length; i++) {
			System.out.println(Integer.toString(intBase[i]));
		}
	}
}

/*
void qsort(
	void *base,
	size_t num,
	size_t width,
	int (__cdecl *compare)(const void *elem1, const void *elem2)
);
 */
@_Call(Arg.CDECL)
class Arg_QSort {
	private int _LastError; 
	
	private int[] base;
	private long num;
	private long width;
	private @_FuncPtr Func_QSortCompareProc compare;
	
	Arg_QSort(int[] base, long num, long width, Func_QSortCompareProc compare) {
		this.base = base;
		this.num = num;
		this.width = width;
		this.compare = compare;
	}
	int getLastError() {return _LastError;}
}

class Func_QSortCompareProc {
	private String _FuncName = "QSortCompareProc";
	private int _ReturnType = Func.RTNTYPE_INT;
	private Arg_QSortCompareProc _FuncArg = new Arg_QSortCompareProc();
	private ClsQSortCompareProc _Instance = new ClsQSortCompareProc();
	//private String _ClassName = "testw32apianno.ClsStaticQSortCompareProc";
}

@_Call(Arg.CDECL)
class Arg_QSortCompareProc {
	private @_Const int[] elem1 = new int[1];
	private @_Const int[] elem2 = new int[1];
	
	int getElem1() {return elem1[0];}
	int getElem2() {return elem2[0];}
}

class ClsQSortCompareProc {
	int QSortCompareProc(Arg_QSortCompareProc aqscp) {
		int elem1 = aqscp.getElem1();
		int elem2 = aqscp.getElem2();
		
		System.out.println("QSortCompareProc elem1:" + Integer.toString(elem1)
				+ " elem2:" + Integer.toString(elem2));
		
		if (elem1 < elem2)
			return -1;
		else if (elem1 == elem2)
			return 0;
		else
			return 1;
	}
}

class ClsStaticQSortCompareProc {
	static int QSortCompareProc(Arg_QSortCompareProc aqscp) {
		int elem1 = aqscp.getElem1();
		int elem2 = aqscp.getElem2();
		
		System.out.println("static QSortCompareProc elem1:" + Integer.toString(elem1)
				+ " elem2:" + Integer.toString(elem2));
		
		if (elem1 < elem2)
			return -1;
		else if (elem1 == elem2)
			return 0;
		else
			return 1;
	}
}
