package testw32apinew;
import utildll.*;

public class TestW32API21 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API21();
	}

	TestW32API21() {
		SnapShot ss = new SnapShot();
		Struct_PROCESSENTRY32 spe = new Struct_PROCESSENTRY32();
		boolean blResult = ss.first(spe);
		
		while (blResult) {
			if (Arg.UNICODE  == CHARSET)
				System.out.println("szExeFile: " + new String(spe.szExeFileW).trim());
			else
				System.out.println("szExeFile: " + new String(spe.szExeFileA).trim());
			blResult = ss.next(spe);
		}
		ss.close();
	}

	static final int MAX_PATH = 260;
	/*
	typedef struct tagPROCESSENTRY32 { 
	  DWORD dwSize; 
	  DWORD cntUsage; 
	  DWORD th32ProcessID; 
	  ULONG_PTR th32DefaultHeapID; 
	  DWORD th32ModuleID; 
	  DWORD cntThreads; 
	  DWORD th32ParentProcessID; 
	  LONG  pcPriClassBase; 
	  DWORD dwFlags; 
	  TCHAR szExeFile[MAX_PATH]; 
	} PROCESSENTRY32; 
	 */
	@_CharSet(CHARSET)
	class Struct_PROCESSENTRY32 {
		int dwSize;
		int cntUsage;
		int th32ProcessID;
		long th32DefaultHeapID;
		int th32ModuleID;
		int cntThreads;
		int th32ParentProcessID;
		int pcPriClassBase;
		int dwFlags;
		//union start
		@_Fixed char szExeFileW[]; 
		@_Fixed byte szExeFileA[]; 
		//union end

		Struct_PROCESSENTRY32() {
			if (Arg.UNICODE  == CHARSET) {
				this.szExeFileW = new char[MAX_PATH];
				this.szExeFileA = null;
			}
			else {
				this.szExeFileW = null;
				this.szExeFileA = new byte[MAX_PATH];
			}
		}
	}

	class SnapShot {
		private String[] strFncName = {"CreateToolhelp32Snapshot",
				"Process32First", "Process32Next", "CloseHandle"};
		private long[] lngFncAdrs = new long[strFncName.length];
		private final int IDX_CreateToolhelp32Snapshot = 0,
				IDX_Process32First = 1, IDX_Process32Next = 2, IDX_CloseHandle = 3;
		private long hSnapShot;
		
		SnapShot() {
			if (Arg.UNICODE  == CHARSET) {
				strFncName[IDX_Process32First] = "Process32FirstW";
				strFncName[IDX_Process32Next] = "Process32NextW";
			}
			Arg_GetModuleHandle agmh = new Arg_GetModuleHandle("kernel32");
			
			long hMod = JInvoker.callIntProc("GetModuleHandle", "kernel32", agmh);
			
			System.out.println("GetModuleHandle rtn: " + Long.toHexString(hMod)
					+ " LastError: " + Integer.toString(agmh.getLastError()));
			
			for (int i = 0; i < strFncName.length; i++) {
				Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
				
				lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
				
				System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
						+ " LastError: " + Integer.toString(agpa.getLastError()));
			}
			
			Arg_CreateToolhelp32Snapshot acts = 
				new Arg_CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
			
			hSnapShot = JInvoker.callLongProcAddress(lngFncAdrs[IDX_CreateToolhelp32Snapshot], acts);
			
			System.out.println("CreateToolhelp32Snapshot rtn: " + Long.toHexString(hSnapShot)
					+ " LastError: " + Integer.toString(acts.getLastError()));
		}
		
		boolean first(Struct_PROCESSENTRY32 spe) {
			Arg_sizeof aso = new Arg_sizeof(spe);
			
			spe.dwSize = (int)JInvoker.sizeof(aso);
			
			System.out.println("sizeof rtn: " + Integer.toString(spe.dwSize)
					+ " LastError: " + Integer.toString(aso.getLastError()));
			
			if (Arg.UNICODE  == CHARSET)
				for (int i = 0; i < spe.szExeFileW.length; i++) spe.szExeFileW[i] = 0;
			else
				for (int i = 0; i < spe.szExeFileA.length; i++) spe.szExeFileA[i] = 0;

			Arg_Process32First apf = new Arg_Process32First(hSnapShot, spe);
			
			boolean blResult = JInvoker.callBooleanProcAddress(lngFncAdrs[IDX_Process32First], apf);
			
			System.out.println("Process32First rtn: " + Boolean.toString(blResult)
					+ " LastError: " + Integer.toString(apf.getLastError()));
			
			return blResult;
		}
		
		boolean next(Struct_PROCESSENTRY32 spe) {
			Arg_sizeof aso = new Arg_sizeof(spe);
			
			spe.dwSize = (int)JInvoker.sizeof(aso);

			//System.out.println("sizeof rtn: " + Integer.toString(spe.dwSize)
			//		+ " LastError: " + Integer.toString(aso.getLastError()));

			if (Arg.UNICODE  == CHARSET)
				for (int i = 0; i < spe.szExeFileW.length; i++) spe.szExeFileW[i] = 0;
			else
				for (int i = 0; i < spe.szExeFileA.length; i++) spe.szExeFileA[i] = 0;

			Arg_Process32Next apn = new Arg_Process32Next(hSnapShot, spe);
			
			boolean blResult = JInvoker.callBooleanProcAddress(lngFncAdrs[IDX_Process32Next], apn);
			
			//System.out.println("Process32Next rtn: " + Boolean.toString(blResult)
			//		+ " LastError: " + Integer.toString(apn.getLastError()));
			
			return blResult;
		}
		
		void close() {
			Arg_CloseHandle ach = new Arg_CloseHandle(hSnapShot);
			
			boolean blResult = JInvoker.callBooleanProcAddress(lngFncAdrs[IDX_CloseHandle], ach);
			
			System.out.println("CloseHandle rtn: " + Boolean.toString(blResult)
					+ " LastError: " + Integer.toString(ach.getLastError()));
		}
		
		class Arg_property {
			private int _LastError;
		
			int getLastError() {return _LastError;}
		}
		
		/*
		HANDLE WINAPI CreateToolhelp32Snapshoti
		  DWORD dwFlags,      
		  DWORD th32ProcessID 
		);
		
		#define TH32CS_SNAPPROCESS  0x00000002
		 */
		class Arg_CreateToolhelp32Snapshot extends Arg_property {
			private int dwFlags;
			private int th32ProcessID;
	
			Arg_CreateToolhelp32Snapshot(int dwFlags, int th32ProcessID) {
				this.dwFlags = dwFlags;
				this.th32ProcessID = th32ProcessID;
			}
		}
		
		static final int TH32CS_SNAPPROCESS = 0x2;
		/*
		BOOL WINAPI Process32Firsti
		  HANDLE hSnapshot,     
		  LPPROCESSENTRY32 lppe 
		);
		 */
		@_CharSet(CHARSET)
		class Arg_Process32First extends Arg_property {
			private long hSnapshot;
			private Struct_PROCESSENTRY32 lppe;
	
			Arg_Process32First(long hSnapshot, Struct_PROCESSENTRY32 lppe) {
				this.hSnapshot = hSnapshot;
				this.lppe = lppe;
			}
		}
		
		/*
		BOOL WINAPI Process32Nexti
		  HANDLE hSnapshot,     
		  LPPROCESSENTRY32 lppe 
		);
		 */
		@_CharSet(CHARSET)
		class Arg_Process32Next extends Arg_property {
			private long hSnapshot;
			private Struct_PROCESSENTRY32 lppe;
	
			Arg_Process32Next(long hSnapshot, Struct_PROCESSENTRY32 lppe) {
				this.hSnapshot = hSnapshot;
				this.lppe = lppe;
			}
		}
		
		/*
		BOOL CloseHandle(
		  HANDLE hObject   // IuWFNg̃nh
		);
		 */
		class Arg_CloseHandle extends Arg_property {
			private long hObject;
	
			Arg_CloseHandle(long hObject) {
				this.hObject = hObject;
			}
		}
		
		/*
		HMODULE LoadLibrary(
		  LPCTSTR lpFileName   // W[̃t@C
		);
		 */
		@_CharSet(CHARSET)
		class Arg_LoadLibrary extends Arg_property {
			private @_Const String lpFileName;
	
			Arg_LoadLibrary(String lpFileName) {
				this.lpFileName = lpFileName;
			}
		}
		
		/*
		HMODULE GetModuleHandle(
		  LPCTSTR lpModuleName   // W[
		);
		 */
		@_CharSet(CHARSET)
		class Arg_GetModuleHandle extends Arg_property {
			private @_Const String lpModuleName;
	
			Arg_GetModuleHandle(String lpModuleName) {
				this.lpModuleName = lpModuleName;
			}
		}
		
		/*
		FARPROC GetProcAddress(
		  HMODULE hModule,    // DLL W[̃nh
		  LPCSTR lpProcName   // ֐
		);
		 */
		@_CharSet(Arg.ANSI)
		class Arg_GetProcAddress extends Arg_property {
			private long hModule;
			private @_Const @_Ansi String lpProcName;
	
			Arg_GetProcAddress(long hModule, String lpProcName) {
				this.hModule = hModule;
				this.lpProcName = lpProcName;
			}
		}
	
		class Arg_sizeof extends Arg_property {
			private @_Const Object obj;
	
			Arg_sizeof(Object obj) {
				this.obj = obj;
			}
		}
	}
}
