package testw32apinew;
import utildll.*;

import java.awt.*;
import java.awt.event.*;

public class TestW32API22 extends Frame{
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;
	Button btn1;
	Button btn2;
	Label lbl1;
	long hHook = 0;
	Func_HookProc fhp;
	long allocAdrs = 0;
	
	public static void main(String[] args) {
		new TestW32API22();
	}
	
	TestW32API22() {
		this.setTitle("HOOKTEST1");
		this.setSize(300, 200);
		this.setLocationRelativeTo(null);
		this.setLayout(new GridLayout(3,1));
		
		BtnAction ba = new BtnAction();
		btn1 = new Button("hook");
		btn1.addActionListener(ba);
		this.add(btn1);
		btn2 = new Button("unhook");
		btn2.addActionListener(ba);
		this.add(btn2);
		lbl1 = new Label();
		lbl1.setAlignment(Label.CENTER);
		this.add(lbl1);
		
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				unhookwin();
				System.exit(0);
			}
		});

		this.setVisible(true);
	}
	
	class BtnAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			if (ev.getSource() == btn1) {
				hookwin();
			}
			else if (ev.getSource() == btn2) {
				unhookwin();
			}
		}
	}
	
	void hookwin() {
		if (hHook == 0) {
			fhp = new Func_HookProc();
			Arg_allocObject aao = new Arg_allocObject(fhp);
			
			allocAdrs = JInvoker.allocObject(aao);
			
			System.out.println("allocObject intAdrs: " + Long.toHexString(allocAdrs)
					+ " LastError: " + Integer.toString(aao.getLastError()));
			
			//GetCurrentThreadIdł͉ʂ̃XbhhcȂ
			//int threadid = JInvoker.callIntProc("GetCurrentThreadId", "kernel32", null);
			
			//System.out.println("GetCurrentThreadId threadid: " + Integer.toHexString(threadid));
			
			Arg_FindWindow afw = new Arg_FindWindow(null, "HOOKTEST1");
			
			long hWnd = JInvoker.callLongProc("FindWindow", "user32", afw);
			
			System.out.println("FindWindow hWnd: " + Long.toHexString(hWnd)
					+ " LastError: " + Integer.toString(afw.getLastError()));
			
			Arg_GetWindowThreadProcessId agwtp = new Arg_GetWindowThreadProcessId(hWnd);
			
			int threadid = JInvoker.callIntProc("GetWindowThreadProcessId", "user32", agwtp);
			
			System.out.println("GetWindowThreadProcessId threadid: " + Integer.toHexString(threadid)
					+ " ProcessId: " + Integer.toHexString(agwtp.getProcessId()));
	
			Arg_SetWindowsHookEx aswh = new Arg_SetWindowsHookEx(
					WH_MOUSE, allocAdrs, 0, threadid);
			
			hHook = JInvoker.callIntProc("SetWindowsHookEx", "user32", aswh);
			
			/*System.out.println("SetWindowsHookEx hHook: " + Integer.toHexString(hHook)
					+ " LastError: " + Integer.toString(aswh.getLastError()));*/
		}
	}

	void unhookwin() {
		if (hHook != 0) {
			Arg_UnhookWindowsHookEx auwh = new Arg_UnhookWindowsHookEx(hHook);
			
			boolean blRtnVal = JInvoker.callBooleanProc("UnhookWindowsHookEx", "user32", auwh);
			
			System.out.println("UnhookWindowsHookEx rtn: " + Boolean.toString(blRtnVal)
					+ " LastError: " + Integer.toString(auwh.getLastError()));
			
			hHook = 0;
			
			int intRtnVal = JInvoker.freeObject(allocAdrs);
			
			System.out.println("freeObject intRtnVal: " + Integer.toString(intRtnVal));
		}
	}

	class ClsMouseProc {
		final static int HC_ACTION = 0;
		int MouseProc(Arg_MouseProc amp) {
			/*System.out.println("MouseProc nCode: " + Integer.toString(amp.getnCode())
					+ " wParam: " + Integer.toString(amp.getwParam())
					+ " lParam: " + Integer.toString(amp.getlParam()));*/
			
			Struct_MOUSEHOOKSTRUCT smh = new Struct_MOUSEHOOKSTRUCT();
			smh.sp = new Struct_POINT();
			Arg_movePtrToObject ampto = new Arg_movePtrToObject(smh);
			
			int intRtnMove = JInvoker.movePtrToObject(ampto, amp.getlParam());
			
			/*System.out.println("movePtrToObject intRtnMove: " + Integer.toString(intRtnMove)
					+ " LastError: " + Integer.toString(ampto.getLastError())
					+ " POINT: " + Integer.toString(smh.sp.x)
					+ ", " + Integer.toString(smh.sp.y)
					+ " hwnd: " + Long.toHexString(smh.hwnd)
					+ " wHitTestCode: " + Integer.toHexString(smh.wHitTestCode)
					+ " dwExtraInfo: " + Integer.toHexString(smh.dwExtraInfo));*/
			
			lbl1.setText(Integer.toString(smh.sp.x) + ", " + Integer.toString(smh.sp.y));
			
			Arg_CallNextHookEx acnh = new Arg_CallNextHookEx(hHook,
				amp.getnCode(), amp.getwParam(), amp.getlParam());

			int intRtnVal = JInvoker.callIntProc("CallNextHookEx", "user32", acnh);
			
			/*System.out.println("CallNextHookEx rtn: " + Integer.toString(intRtnVal));*/

			return intRtnVal;
			
		}
	}

	final static int WH_MOUSE = 7;
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HHOOK SetWindowsHookEx(
	  int idHook,        // tbN^Cv
	  HOOKPROC lpfn,     // tbNvV[W
	  HINSTANCE hMod,    // AvP[VCX^X̃nh
	  DWORD dwThreadId   // Xbh̎ʎq
	);
	*/
	class Arg_SetWindowsHookEx extends Arg_property {
		private int idHook;
		private long lpfn;
		private long hMod;
		private int dwThreadId;
		
		Arg_SetWindowsHookEx(int idHook, long lpfn, long hMod, int dwThreadId) {
			this.idHook = idHook;
			this.lpfn = lpfn;
			this.hMod = hMod;
			this.dwThreadId = dwThreadId;
		}
	}
	
	/*
	BOOL UnhookWindowsHookEx(
	  HHOOK hhk   // 폜Ώۂ̃tbNvV[W̃nh
	);
	*/
	class Arg_UnhookWindowsHookEx extends Arg_property {
		private long hhk;
		
		Arg_UnhookWindowsHookEx(long hhk) {
			this.hhk = hhk;
		}
	}
	
	class Arg_allocObject extends Arg_property {
		private @_FuncPtr Object obj;
		
		Arg_allocObject(Object obj) {
			this.obj = obj;
		}
	}

	class Func_HookProc {
		private String _FuncName = "MouseProc";
		private int _ReturnType = Func.RTNTYPE_INT;
		private Arg_MouseProc _FuncArg = new Arg_MouseProc();
		private ClsMouseProc _Instance = new ClsMouseProc();
		//private String _ClassName = "testw32apinew.ClsStaticMouseProc";
	}
	
	/*
	LRESULT CALLBACK MouseProc(
	  int nCode,      // tbNR[h
	  WPARAM wParam,  // bZ[Wʎq
	  LPARAM lParam   // }EX̍W
	);
	*/
	class Arg_MouseProc	{
		private int nCode;
		private long wParam;
		private long lParam;
		
		int getnCode() {return nCode;}
		long getwParam() {return wParam;}
		long getlParam() {return lParam;}
	}
	
	/*
	typedef struct tagMOUSEHOOKSTRUCT { 
	    POINT     pt; 
	    HWND      hwnd; 
	    UINT      wHitTestCode; 
	    ULONG_PTR dwExtraInfo; 
	} MOUSEHOOKSTRUCT, *PMOUSEHOOKSTRUCT;
	*/
	class Struct_MOUSEHOOKSTRUCT {
		@_Fixed Struct_POINT sp;
		long hwnd;
		int wHitTestCode;
		long dwExtraInfo;
	}
	
	/*
	typedef struct tagPOINT { 
	  LONG x; 
	  LONG y; 
	} POINT, *PPOINT;
	*/
	class Struct_POINT {
		int x;
		int y;
	}
	
	class Arg_movePtrToObject extends Arg_property {
		private Object obj;
		
		Arg_movePtrToObject(Object obj) {
			this.obj = obj;
		}
	}
	
	/*
	LRESULT CallNextHookEx(
	  HHOOK hhk,      // ݂̃tbÑnh
	  int nCode,      // tbNvV[WɓntbNR[h
	  WPARAM wParam,  // tbNvV[Wɓnl
	  LPARAM lParam   // tbNvV[Wɓnl
	);
	 */
	class Arg_CallNextHookEx extends Arg_property {
		private long hhk;
		private int nCode;
		private long wParam;
		private long lParam;
		
		Arg_CallNextHookEx(long hhk, int nCode, long wParam, long lParam) {
			this.hhk = hhk;
			this.nCode = nCode;
			this.wParam = wParam;
			this.lParam = lParam;
		}
	}
	
	/*
	HWND FindWindow(
	  LPCTSTR lpClassName,  // NX
	  LPCTSTR lpWindowName  // EBhE
	);
	*/
	@_CharSet(CHARSET)
	class Arg_FindWindow extends Arg_property {
		private @_Const String lpClassName;
		private @_Const String lpWindowName;
		
		Arg_FindWindow(String lpClassName, String lpWindowName) {
			this.lpClassName = lpClassName;
			this.lpWindowName = lpWindowName;
		}
	}
	
	/*
	DWORD GetWindowThreadProcessId(
	  HWND hWnd,             // EBhẼnh
	  LPDWORD lpdwProcessId  // vZX ID
	);
	 */
	class Arg_GetWindowThreadProcessId extends Arg_property {
		private long hWnd;
		private int[] lpdwProcessId = new int[1];
		Arg_GetWindowThreadProcessId(long hWnd) {
			this.hWnd = hWnd;
		}
		int getProcessId() {return lpdwProcessId[0];}
	}
	
}