package testw32apinew;
import utildll.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class TestW32API23 extends JFrame{
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;
	JButton btn1;
	JButton btn2;
	JLabel lbl1;
	long hHook = 0;
	long hWnd = 0;
	Func_HookProc fhp;
	long allocAdrs = 0;

	public static void main(String[] args) {
		new TestW32API23();
	}
	
	TestW32API23() {
		this.setTitle("HOOKTEST2");
		this.setSize(300, 200);
		this.setLocationRelativeTo(null);
		Container cntnr = getContentPane();
		cntnr.setLayout(new GridLayout(3,1));
		
		BtnAction ba = new BtnAction();
		btn1 = new JButton("hook");
		btn1.addActionListener(ba);
		cntnr.add(btn1);
		btn2 = new JButton("unhook");
		btn2.addActionListener(ba);
		cntnr.add(btn2);
		lbl1 = new JLabel();
		lbl1.setHorizontalAlignment(JLabel.CENTER);
		cntnr.add(lbl1);
		
		fhp = new Func_HookProc();
		Arg_allocObject aao = new Arg_allocObject(fhp);
		
		allocAdrs = JInvoker.allocObject(aao);
		
		System.out.println("allocObject intAdrs: " + Long.toHexString(allocAdrs)
				+ " LastError: " + Integer.toString(aao.getLastError()));

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				int intRtnVal = JInvoker.freeObject(allocAdrs);
				
				System.out.println("freeObject intRtnVal: " + Integer.toString(intRtnVal));

				System.exit(0);
			}
		});

		this.setVisible(true);
		
	}

	class BtnAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			if (ev.getSource() == btn1) {
				hookwin();
			}
			else if (ev.getSource() == btn2) {
				unhookwin();
			}
		}
	}

	void hookwin() {
		if (hHook == 0) {
			
			Arg_FindWindow afw = new Arg_FindWindow(null, "HOOKTEST2");
			
			hWnd = JInvoker.callLongProc("FindWindow", "user32", afw);
			
			System.out.println("FindWindow hWnd: " + Long.toHexString(hWnd)
					+ " LastError: " + Integer.toString(afw.getLastError()));
			
			Arg_SetWindowLongPtr aswl = new Arg_SetWindowLongPtr(hWnd, GWLP_WNDPROC, allocAdrs);
			
			hHook = JInvoker.callLongProc("SetWindowLongPtr", "user32", aswl);
			
			/*System.out.println("SetWindowLongPtr hHook: " + Long.toHexString(hHook)
					+ " LastError: " + Integer.toString(aswl.getLastError()));*/
			
		}
	}
	
	void unhookwin() {
		if (hHook != 0) {
			
			Arg_SetWindowLongPtr aswl = new Arg_SetWindowLongPtr(hWnd, GWLP_WNDPROC, hHook);
			
			hHook = JInvoker.callLongProc("SetWindowLongPtr", "user32", aswl);
			
			/*System.out.println("SetWindowLong hHook: " + Long.toHexString(hHook)
					+ " LastError: " + Integer.toString(aswl.getLastError()));*/

			hHook = 0;
		
		}
	}
	
	class ClsWindowProc {
		final static int WM_MOUSEMOVE = 0x0200;
		int WindowProc(Arg_WindowProc awp) {
			/*System.out.println("WindowProc hwnd: " + Integer.toString(awp.gethwnd())
					+ " uMsg: " + Integer.toString(awp.getuMsg())
					+ " wParam: " + Long.toString(awp.getwParam())
					+ " lParam: " + Long.toHexString(awp.getlParam()));*/
			
			switch (awp.getuMsg()) {
			case WM_MOUSEMOVE:
				lbl1.setText(Long.toString(awp.getlParam() >> 16)
						+ ", " + Long.toString(awp.getlParam() & 0xffff));
				break;
			}
			
			Arg_CallWindowProc acwp = new Arg_CallWindowProc(hHook,
					awp.gethwnd(), awp.getuMsg(), awp.getwParam(), awp.getlParam());
			
			int intRtnVal = JInvoker.callIntProc("CallWindowProc", "user32", acwp);
			
			return intRtnVal;
		}
	}

	final static int GWLP_WNDPROC = (-4);
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	LONG_PTR SetWindowLongPtr(
	  HWND hWnd,       // EBhẼnh
	  int nIndex,      // ݒ肷l̃ItZbg
	  LONG_PTR dwNewLong   // Vl
	);
	 */
	class Arg_SetWindowLongPtr extends Arg_property {
		private long hWnd;
		private int nIndex;
		private long dwNewLong;
		
		Arg_SetWindowLongPtr(long hWnd, int nIndex, long dwNewLong) {
			this.hWnd = hWnd;
			this.nIndex = nIndex;
			this.dwNewLong = dwNewLong;
		}
	}
	
	class Arg_allocObject extends Arg_property {
		private @_FuncPtr Object obj;
		
		Arg_allocObject(Object obj) {
			this.obj = obj;
		}
	}

	class Func_HookProc {
		private String _FuncName = "WindowProc";
		private int _ReturnType = Func.RTNTYPE_INT;
		private Arg_WindowProc _FuncArg = new Arg_WindowProc();
		private ClsWindowProc _Instance = new ClsWindowProc();
	}
	
	/*
	LRESULT CALLBACK WindowProc(
	  HWND hwnd,      // EBhẼnh
	  UINT uMsg,      // bZ[W̎ʎq
	  WPARAM wParam,  // bZ[W̍ŏ̃p[^
	  LPARAM lParam   // bZ[W 2 Ԗڂ̃p[^
	);
	 */
	class Arg_WindowProc {
		private long hwnd;
		private int uMsg;
		private long wParam;
		private long lParam;
		
		long gethwnd() {return hwnd;}
		int getuMsg() {return uMsg;}
		long getwParam() {return wParam;}
		long getlParam() {return lParam;}
	}
	
	/*
	LRESULT CallWindowProc(
	  WNDPROC lpPrevWndFunc,  // ̃EBhEvV[W
	  HWND hWnd,              // EBhẼnh
	  UINT Msg,               // bZ[W
	  WPARAM wParam,          // bZ[W̍ŏ̃p[^
	  LPARAM lParam           // bZ[W 2 Ԗڂ̃p[^
	);
	 */
	class Arg_CallWindowProc extends Arg_property {
		private long lpPrevWndFunc;
		private long hwnd;
		private int Msg;
		private long wParam;
		private long lParam;
		
		Arg_CallWindowProc(long lpPrevWndFunc, long hwnd, int Msg, long wParam, long lParam) {
			this.lpPrevWndFunc = lpPrevWndFunc;
			this.hwnd = hwnd;
			this.Msg = Msg;
			this.wParam = wParam;
			this.lParam = lParam;
		}
	}
	
	/*
	HWND FindWindow(
	  LPCTSTR lpClassName,  // NX
	  LPCTSTR lpWindowName  // EBhE
	);
	*/
	@_CharSet(CHARSET)
	class Arg_FindWindow extends Arg_property {
		private @_Const String lpClassName;
		private @_Const String lpWindowName;
		
		Arg_FindWindow(String lpClassName, String lpWindowName) {
			this.lpClassName = lpClassName;
			this.lpWindowName = lpWindowName;
		}
	}
}
