package testw32apinew;
import utildll.*;

public class TestW32API24 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;

	/*
	#include <windows.h>
	#include <tchar.h>
	#include <stdio.h>
	#include <strsafe.h>
	
	#pragma comment(lib, "User32.lib")
	
	#define BUFSIZE 256
	
	typedef void (WINAPI *PGNSI)(LPSYSTEM_INFO);
	typedef BOOL (WINAPI *PGPI)(DWORD, DWORD, DWORD, DWORD, PDWORD);
	*/
	final int BUFSIZE = 256;

	/*BOOL GetOSDisplayString( LPTSTR pszOS)*/
	boolean GetOSDisplayString(StringBuffer pszOS)
	{
		/*
		OSVERSIONINFOEX osvi;
		SYSTEM_INFO si;
		PGNSI pGNSI;
		PGPI pGPI;
		BOOL bOsVersionInfoEx;
		DWORD dwType;
		*/
		Struct_OSVERSIONINFOEX osvi = new Struct_OSVERSIONINFOEX();
		Struct_SYSTEM_INFO si = new Struct_SYSTEM_INFO(1);
		long pGNSI;
		long pGPI;
		boolean bOsVersionInfoEx;
		int[] dwType = new int[1];
		
		/*
		ZeroMemory(&si, sizeof(SYSTEM_INFO));
		ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
		
		osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
		bOsVersionInfoEx = GetVersionEx((OSVERSIONINFO*) &osvi);
		*/
		osvi.dwOSVersionInfoSize = (int)sizeof(osvi);
		bOsVersionInfoEx = GetVersionEx(osvi);
		
	   /*if(bOsVersionInfoEx != NULL ) return 1;*/
		if (!bOsVersionInfoEx) return FALSE;
		
	   // Call GetNativeSystemInfo if supported or GetSystemInfo otherwise.
		/*
		pGNSI = (PGNSI) GetProcAddress(
			GetModuleHandle(TEXT("kernel32.dll")), 
			"GetNativeSystemInfo");
		if(NULL != pGNSI)
			pGNSI(&si);
		else GetSystemInfo(&si);
	   */
		pGNSI = GetProcAddress(
				GetModuleHandle(TEXT("kernel32.dll")), 
				"GetNativeSystemInfo");
	   if (NULL != pGNSI)
		   GetNativeSystemInfo(pGNSI, si);
	   else GetSystemInfo(si);
	   
	   
	   if ( VER_PLATFORM_WIN32_NT==osvi.dwPlatformId && 
	        osvi.dwMajorVersion > 4 )
	   {
	      StringCchCopy(pszOS, BUFSIZE, TEXT("Microsoft "));

	      // Test for the specific product.

	      if ( osvi.dwMajorVersion == 6 )
	      {
	         if( osvi.dwMinorVersion == 0 )
	         {
	            if( osvi.wProductType == VER_NT_WORKSTATION )
	                StringCchCat(pszOS, BUFSIZE, TEXT("Windows Vista "));
	            else StringCchCat(pszOS, BUFSIZE, TEXT("Windows Server 2008 " ));
	         }

	         if ( osvi.dwMinorVersion == 1 )
	         {
	            if( osvi.wProductType == VER_NT_WORKSTATION )
	                StringCchCat(pszOS, BUFSIZE, TEXT("Windows 7 "));
	            else StringCchCat(pszOS, BUFSIZE, TEXT("Windows Server 2008 R2 " ));
	         }
	         
	         /*
	         pGPI = (PGPI) GetProcAddress(
	            GetModuleHandle(TEXT("kernel32.dll")), 
	            "GetProductInfo");

	         pGPI( osvi.dwMajorVersion, osvi.dwMinorVersion, 0, 0, &dwType);
			*/
	         pGPI = GetProcAddress(
	 	            GetModuleHandle(TEXT("kernel32.dll")), 
	 	            "GetProductInfo");

	         GetProductInfo(pGPI, osvi.dwMajorVersion, osvi.dwMinorVersion, 0, 0, dwType);
	         
	         /*switch( dwType )*/
	         switch( dwType[0] )
	         {
	            case PRODUCT_ULTIMATE:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Ultimate Edition" ));
	               break;
	            case PRODUCT_PROFESSIONAL:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Professional" ));
	               break;
	            case PRODUCT_HOME_PREMIUM:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Home Premium Edition" ));
	               break;
	            case PRODUCT_HOME_BASIC:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Home Basic Edition" ));
	               break;
	            case PRODUCT_ENTERPRISE:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Enterprise Edition" ));
	               break;
	            case PRODUCT_BUSINESS:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Business Edition" ));
	               break;
	            case PRODUCT_STARTER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Starter Edition" ));
	               break;
	            case PRODUCT_CLUSTER_SERVER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Cluster Server Edition" ));
	               break;
	            case PRODUCT_DATACENTER_SERVER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Datacenter Edition" ));
	               break;
	            case PRODUCT_DATACENTER_SERVER_CORE:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Datacenter Edition (core installation)" ));
	               break;
	            case PRODUCT_ENTERPRISE_SERVER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Enterprise Edition" ));
	               break;
	            case PRODUCT_ENTERPRISE_SERVER_CORE:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Enterprise Edition (core installation)" ));
	               break;
	            case PRODUCT_ENTERPRISE_SERVER_IA64:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Enterprise Edition for Itanium-based Systems" ));
	               break;
	            case PRODUCT_SMALLBUSINESS_SERVER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Small Business Server" ));
	               break;
	            case PRODUCT_SMALLBUSINESS_SERVER_PREMIUM:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Small Business Server Premium Edition" ));
	               break;
	            case PRODUCT_STANDARD_SERVER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Standard Edition" ));
	               break;
	            case PRODUCT_STANDARD_SERVER_CORE:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Standard Edition (core installation)" ));
	               break;
	            case PRODUCT_WEB_SERVER:
	               StringCchCat(pszOS, BUFSIZE, TEXT("Web Server Edition" ));
	               break;
	         }
	      }

	      if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2 )
	      {
	         if( GetSystemMetrics(SM_SERVERR2) )
	            StringCchCat(pszOS, BUFSIZE, TEXT( "Windows Server 2003 R2, "));
	         /*else if ( osvi.wSuiteMask & VER_SUITE_STORAGE_SERVER )*/
		     else if (( osvi.wSuiteMask & VER_SUITE_STORAGE_SERVER ) != 0)
	            StringCchCat(pszOS, BUFSIZE, TEXT( "Windows Storage Server 2003"));
	         /*else if ( osvi.wSuiteMask & VER_SUITE_WH_SERVER )*/
		     else if (( osvi.wSuiteMask & VER_SUITE_WH_SERVER ) != 0)
	            StringCchCat(pszOS, BUFSIZE, TEXT( "Windows Home Server"));
	         else if( osvi.wProductType == VER_NT_WORKSTATION &&
	                  /*si.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64)*/
                 	  si.uop.spa.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64)
	         {
	            StringCchCat(pszOS, BUFSIZE, TEXT( "Windows XP Professional x64 Edition"));
	         }
	         else StringCchCat(pszOS, BUFSIZE, TEXT("Windows Server 2003, "));

	         // Test for the server type.
	         if ( osvi.wProductType != VER_NT_WORKSTATION )
	         {
	            /*if ( si.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_IA64 )*/
		        if ( si.uop.spa.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_IA64 )
	            {
	                /*if( osvi.wSuiteMask & VER_SUITE_DATACENTER )*/
		            if(( osvi.wSuiteMask & VER_SUITE_DATACENTER ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Datacenter Edition for Itanium-based Systems" ));
	                /*else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )*/
		            else if(( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Enterprise Edition for Itanium-based Systems" ));
	            }

	            /*else if ( si.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64 )*/
		        else if ( si.uop.spa.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64 )
	            {
	                /*if( osvi.wSuiteMask & VER_SUITE_DATACENTER )*/
		            if(( osvi.wSuiteMask & VER_SUITE_DATACENTER ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Datacenter x64 Edition" ));
	                /*else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )*/
		            else if(( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Enterprise x64 Edition" ));
	                else StringCchCat(pszOS, BUFSIZE, TEXT( "Standard x64 Edition" ));
	            }

	            else
	            {
	                /*if ( osvi.wSuiteMask & VER_SUITE_COMPUTE_SERVER )*/
		            if (( osvi.wSuiteMask & VER_SUITE_COMPUTE_SERVER ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Compute Cluster Edition" ));
	                /*else if( osvi.wSuiteMask & VER_SUITE_DATACENTER )*/
		            else if(( osvi.wSuiteMask & VER_SUITE_DATACENTER ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Datacenter Edition" ));
	                /*else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )*/
		            else if(( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Enterprise Edition" ));
	                /*else if ( osvi.wSuiteMask & VER_SUITE_BLADE )*/
		            else if (( osvi.wSuiteMask & VER_SUITE_BLADE ) != 0)
	                   StringCchCat(pszOS, BUFSIZE, TEXT( "Web Edition" ));
	                else StringCchCat(pszOS, BUFSIZE, TEXT( "Standard Edition" ));
	            }
	         }
	      }

	      if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 )
	      {
	         StringCchCat(pszOS, BUFSIZE, TEXT("Windows XP "));
	         /*if( osvi.wSuiteMask & VER_SUITE_PERSONAL )*/
		     if(( osvi.wSuiteMask & VER_SUITE_PERSONAL ) != 0)
	            StringCchCat(pszOS, BUFSIZE, TEXT( "Home Edition" ));
	         else StringCchCat(pszOS, BUFSIZE, TEXT( "Professional" ));
	      }

	      if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 )
	      {
	         StringCchCat(pszOS, BUFSIZE, TEXT("Windows 2000 "));

	         if ( osvi.wProductType == VER_NT_WORKSTATION )
	         {
	            StringCchCat(pszOS, BUFSIZE, TEXT( "Professional" ));
	         }
	         else 
	         {
	            /*if( osvi.wSuiteMask & VER_SUITE_DATACENTER )*/
		        if(( osvi.wSuiteMask & VER_SUITE_DATACENTER ) != 0)
	               StringCchCat(pszOS, BUFSIZE, TEXT( "Datacenter Server" ));
	            /*else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )*/
		        else if(( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ) != 0)
	               StringCchCat(pszOS, BUFSIZE, TEXT( "Advanced Server" ));
	            else StringCchCat(pszOS, BUFSIZE, TEXT( "Server" ));
	         }
	      }

	       // Include service pack (if any) and build number.
	      /*
	      if( _tcslen(osvi.szCSDVersion) > 0 )
	      {
	          StringCchCat(pszOS, BUFSIZE, TEXT(" ") );
	          StringCchCat(pszOS, BUFSIZE, osvi.szCSDVersion);
	      }
			*/
			if (Arg.UNICODE  == CHARSET) {
			      if( new String(osvi.szCSDVersionW).trim().length() > 0 )
			      {
			          StringCchCat(pszOS, BUFSIZE, TEXT(" ") );
			          StringCchCat(pszOS, BUFSIZE, new String(osvi.szCSDVersionW).trim());
			      }
			}
			else {
			      if( new String(osvi.szCSDVersionA).trim().length() > 0 )
			      {
			          StringCchCat(pszOS, BUFSIZE, TEXT(" ") );
			          StringCchCat(pszOS, BUFSIZE, new String(osvi.szCSDVersionA).trim());
			      }
			}

	      /*TCHAR buf[80];*/
	      StringBuffer buf = new StringBuffer(80);
	      
	      StringCchPrintf( buf, 80, TEXT(" (build %d)"), osvi.dwBuildNumber);
	      /*StringCchCat(pszOS, BUFSIZE, buf);*/
	      StringCchCat(pszOS, BUFSIZE, buf.toString());

	      if ( osvi.dwMajorVersion >= 6 )
	      {
	         /*if ( si.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64 )*/
		     if ( si.uop.spa.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64 )
	            StringCchCat(pszOS, BUFSIZE, TEXT( ", 64-bit" ));
	         /*else if (si.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_INTEL )*/
		     else if (si.uop.spa.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_INTEL )
	            StringCchCat(pszOS, BUFSIZE, TEXT(", 32-bit"));
	      }
	      
	      return TRUE; 
	   }

	   else
	   {  
	      printf( "This sample does not support this version of Windows.\n");
	      return FALSE;
	   }
	}

	/*int __cdecl _tmain()*/
	public static void main(String[] args)
	{
		new TestW32API24();
	}
	
	TestW32API24() {
		/*TCHAR szOS[BUFSIZE];*/
		StringBuffer szOS = new StringBuffer(BUFSIZE);

	    if( GetOSDisplayString( szOS ) )
	        _tprintf( TEXT("\n%s\n"), szOS );
	}
	
	private String TEXT(String str) {
		return str;
	}
	
	private void StringCchCopy(StringBuffer sb, int sz, String str) {
		sb.append(str);
	}

	private void StringCchCat(StringBuffer sb, int sz, String str) {
		sb.append(str);
	}
	
	private void StringCchPrintf(StringBuffer sb, int sz, String fmt, int i) {
		String str = String.format(fmt, i);
		sb.append(str);
	}
	
	private void printf(String str) {
		System.out.printf(str);
	}
	
	private void _tprintf(String fmt, StringBuffer sb) {
		String str = String.format(fmt, sb.toString());
		System.out.printf(str);
	}

	private long sizeof(Object obj) {
		Arg_sizeof aso = new Arg_sizeof(obj);
		
		long sz = JInvoker.sizeof(aso);
		
		System.out.println("sizeof rtn: " + Long.toString(sz)
				+ " LastError: " + Integer.toString(aso.getLastError()));
		
		return sz;
	}

	class Arg_property {
		private int _LastError;

		int getLastError() {return _LastError;}
	}

	class Arg_sizeof extends Arg_property{
		private @_Const Object obj;

		Arg_sizeof(Object obj) {
			this.obj = obj;
		}
	}

	private long GetModuleHandle(String lpModuleName) {
		Arg_GetModuleHandle agmh = new Arg_GetModuleHandle(lpModuleName);
		
		long hMod = JInvoker.callLongProc("GetModuleHandle", "kernel32", agmh);
		
		System.out.println("GetModuleHandle rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(agmh.getLastError()));
		
		return hMod;
	}
	
	/*
	HMODULE GetModuleHandle(
	  LPCTSTR lpModuleName   // W[
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetModuleHandle extends Arg_property {
		private @_Const String lpModuleName;

		Arg_GetModuleHandle(String lpModuleName) {
			this.lpModuleName = lpModuleName;
		}
	}

	private long GetProcAddress(long hModule, String lpProcName) {
		Arg_GetProcAddress agpa = new Arg_GetProcAddress(hModule, lpProcName);
		
		long lngFncAdrs = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
		
		System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs)
				+ " LastError: " + Integer.toString(agpa.getLastError()));
		
		return lngFncAdrs;
	}
	
	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}

	private boolean GetVersionEx(Struct_OSVERSIONINFOEX sovi) {
		Arg_GetVersionEx agv = new Arg_GetVersionEx(sovi);
		
		boolean blResult = JInvoker.callBooleanProc("GetVersionEx", "kernel32", agv);
		
		System.out.println("GetVersionEx rtn: " + Boolean.toString(blResult)
				+ " LastError: " + Integer.toString(agv.getLastError()));
		System.out.println("osvi.dwMajorVersion: " + Integer.toHexString(sovi.dwMajorVersion));
		System.out.println("osvi.dwMinorVersion: " + Integer.toHexString(sovi.dwMinorVersion));
		System.out.println("osvi.dwBuildNumber: " + Integer.toString(sovi.dwBuildNumber));
		System.out.println("osvi.dwPlatformId: " + Integer.toHexString(sovi.dwPlatformId));
		if (Arg.UNICODE  == CHARSET)
			System.out.println("osvi.szCSDVersion: " + new String(sovi.szCSDVersionW).trim());
		else
			System.out.println("osvi.szCSDVersion: " + new String(sovi.szCSDVersionA).trim());
		System.out.println("osvi.wServicePackMajor: " + Integer.toHexString(sovi.wServicePackMajor));
		System.out.println("osvi.wServicePackMinor: " + Integer.toHexString(sovi.wServicePackMinor));
		System.out.println("osvi.wSuiteMask: " + Integer.toHexString(sovi.wSuiteMask));
		System.out.println("osvi.wProductType: " + Integer.toHexString(sovi.wProductType));
			
		return blResult;
	}
	
	/*
	BOOL GetVersionEx(
	  LPOSVERSIONINFO lpVersionInfo // o[W
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetVersionEx extends Arg_property {
		private Struct_OSVERSIONINFOEX lpVersionInfo;

		Arg_GetVersionEx(Struct_OSVERSIONINFOEX lpVersionInfo) {
			this.lpVersionInfo = lpVersionInfo;
		}
	}
	
	/*
	typedef struct _OSVERSIONINFO{ 
	  DWORD dwOSVersionInfoSize; 
	  DWORD dwMajorVersion; 
	  DWORD dwMinorVersion; 
	  DWORD dwBuildNumber; 
	  DWORD dwPlatformId; 
	  TCHAR szCSDVersion[ 128 ]; 
	} OSVERSIONINFO;

	typedef struct _OSVERSIONINFOEX {
	  DWORD dwOSVersionInfoSize;
	  DWORD dwMajorVersion;
	  DWORD dwMinorVersion;
	  DWORD dwBuildNumber;
	  DWORD dwPlatformId;
	  TCHAR szCSDVersion[ 128 ];
	  WORD wServicePackMajor;
	  WORD wServicePackMinor;
	  WORD wSuiteMask;
	  BYTE wProductType;
	  BYTE wReserved;
	} OSVERSIONINFOEX
	 */
	
	@_CharSet(CHARSET)
	class Struct_OSVERSIONINFO {
		int dwOSVersionInfoSize;
		int dwMajorVersion;
		int dwMinorVersion;
		int dwBuildNumber;
		int dwPlatformId;
		//union start
		@_Fixed char szCSDVersionW[]; 
		@_Fixed byte szCSDVersionA[]; 
		//union end

		Struct_OSVERSIONINFO() {
			if (Arg.UNICODE  == CHARSET) {
				this.szCSDVersionW = new char[128];
				this.szCSDVersionA = null;
			}
			else {
				this.szCSDVersionW = null;
				this.szCSDVersionA = new byte[128];
			}
		}
	}
	
	@_CharSet(CHARSET)
	class Struct_OSVERSIONINFOEX extends Struct_OSVERSIONINFO{
		short wServicePackMajor;
		short wServicePackMinor;
		short wSuiteMask;
		byte wProductType;
		byte wReserved;

		Struct_OSVERSIONINFOEX() {
			super();
		}
	}
	
	private void GetNativeSystemInfo(long procadrs, Struct_SYSTEM_INFO lpSystemInfo) {
		Arg_GetNativeSystemInfo agnsi = new Arg_GetNativeSystemInfo(lpSystemInfo);
		
		JInvoker.callVoidProcAddress(procadrs, agnsi);
		
		System.out.println("GetNativeSystemInfo "
				+ " LastError: " + Integer.toString(agnsi.getLastError()));
		System.out.println("si.wProcessorArchitecture: " + Integer.toHexString(lpSystemInfo.uop.spa.wProcessorArchitecture));
		System.out.println("si.dwPageSize: " + Integer.toHexString(lpSystemInfo.dwPageSize));
		System.out.println("si.lpMinimumApplicationAddress: " + Long.toHexString(lpSystemInfo.lpMinimumApplicationAddress));
		System.out.println("si.lpMaximumApplicationAddress: " + Long.toHexString(lpSystemInfo.lpMaximumApplicationAddress));
		System.out.println("si.dwActiveProcessorMask: " + Integer.toHexString(lpSystemInfo.dwActiveProcessorMask));
		System.out.println("si.dwNumberOfProcessors: " + Integer.toHexString(lpSystemInfo.dwNumberOfProcessors));
		System.out.println("si.dwProcessorType: " + Integer.toHexString(lpSystemInfo.dwProcessorType));
		System.out.println("si.dwAllocationGranularity: " + Integer.toHexString(lpSystemInfo.dwAllocationGranularity));
		System.out.println("si.wProcessorLevel: " + Integer.toHexString(lpSystemInfo.wProcessorLevel));
		System.out.println("si.wProcessorRevision: " + Integer.toHexString(lpSystemInfo.wProcessorRevision));
	}
	
	/*
	VOID GetNativeSystemInfo(
		LPSYSTEM_INFO lpSystemInfo
	);
	 */
	class Arg_GetNativeSystemInfo extends Arg_property {
		private Struct_SYSTEM_INFO lpSystemInfo;

		Arg_GetNativeSystemInfo(Struct_SYSTEM_INFO lpSystemInfo) {
			this.lpSystemInfo = lpSystemInfo;
		}
	}
	
	private void GetSystemInfo(Struct_SYSTEM_INFO lpSystemInfo) {
		Arg_GetSystemInfo agsi = new Arg_GetSystemInfo(lpSystemInfo);
		
		JInvoker.callVoidProc("GetSystemInfo", "kernel32", agsi);
		
		System.out.println("GetSystemInfo "
				+ " LastError: " + Integer.toString(agsi.getLastError()));
		System.out.println("si.wProcessorArchitecture: " + Integer.toHexString(lpSystemInfo.uop.spa.wProcessorArchitecture));
		System.out.println("si.dwPageSize: " + Integer.toHexString(lpSystemInfo.dwPageSize));
		System.out.println("si.lpMinimumApplicationAddress: " + Long.toHexString(lpSystemInfo.lpMinimumApplicationAddress));
		System.out.println("si.lpMaximumApplicationAddress: " + Long.toHexString(lpSystemInfo.lpMaximumApplicationAddress));
		System.out.println("si.dwActiveProcessorMask: " + Integer.toHexString(lpSystemInfo.dwActiveProcessorMask));
		System.out.println("si.dwNumberOfProcessors: " + Integer.toHexString(lpSystemInfo.dwNumberOfProcessors));
		System.out.println("si.dwProcessorType: " + Integer.toHexString(lpSystemInfo.dwProcessorType));
		System.out.println("si.dwAllocationGranularity: " + Integer.toHexString(lpSystemInfo.dwAllocationGranularity));
		System.out.println("si.wProcessorLevel: " + Integer.toHexString(lpSystemInfo.wProcessorLevel));
		System.out.println("si.wProcessorRevision: " + Integer.toHexString(lpSystemInfo.wProcessorRevision));
	}

	/*
	VOID GetSystemInfo(
	  LPSYSTEM_INFO lpSystemInfo  // VXe
	);
	 */
	class Arg_GetSystemInfo extends Arg_property {
		private Struct_SYSTEM_INFO lpSystemInfo;

		Arg_GetSystemInfo(Struct_SYSTEM_INFO lpSystemInfo) {
			this.lpSystemInfo = lpSystemInfo;
		}
	}
	
	/*
	typedef struct _SYSTEM_INFO { 
	  union { 
	    DWORD  dwOemId; 
	    struct { 
	      WORD wProcessorArchitecture; 
	      WORD wReserved; 
	    }; 
	  }; 
	  DWORD  dwPageSize; 
	  LPVOID lpMinimumApplicationAddress; 
	  LPVOID lpMaximumApplicationAddress; 
	  DWORD_PTR dwActiveProcessorMask; 
	  DWORD dwNumberOfProcessors; 
	  DWORD dwProcessorType; 
	  DWORD dwAllocationGranularity; 
	  WORD wProcessorLevel; 
	  WORD wProcessorRevision; 
	} SYSTEM_INFO; 
	 */
	class Struct_SYSTEM_INFO {
		@_Fixed Union_OemProc uop = new Union_OemProc();
		int dwPageSize;
		long lpMinimumApplicationAddress;
		long lpMaximumApplicationAddress;
		int dwActiveProcessorMask;
		int dwNumberOfProcessors;
		int dwProcessorType;
		int dwAllocationGranularity;
		short wProcessorLevel;
		short wProcessorRevision;

		Struct_SYSTEM_INFO(int sw) {
			this.uop._Switch = sw;
		}
	}
	
	class Union_property {
		int _Switch;
	}
	
	class Union_OemProc extends Union_property{
		@_Case(0)
			int dwOemId; //Windows NT 3.5 and earlier
		@_Default
			@_Fixed Struct_ProcArc spa = new Struct_ProcArc();
	}
	
	class Struct_ProcArc {
		short wProcessorArchitecture;
		short wReserved;
	}
	
	private boolean GetProductInfo(long procadrs,
			int dwOSMajorVersion, int dwOSMinorVersion,
			int dwSpMajorVersion, int dwSpMinorVersion,
			int[] pdwReturnedProductType) {
		
		Arg_GetProductInfo agpi = new Arg_GetProductInfo(
				dwOSMajorVersion, dwOSMinorVersion,
				dwSpMajorVersion, dwSpMinorVersion,
				pdwReturnedProductType);
		
		boolean blResult = JInvoker.callBooleanProcAddress(procadrs, agpi);
		
		System.out.println("GetProductInfo rtn: " + Boolean.toString(blResult)
				+ " LastError: " + Integer.toString(agpi.getLastError())
				+ " pdwReturnedProductType: " + Integer.toHexString(agpi.pdwReturnedProductType[0]));
		
		return blResult;
	}
	
	/*
	BOOL
	GetProductInfo(
	    __in  DWORD  dwOSMajorVersion,
	    __in  DWORD  dwOSMinorVersion,
	    __in  DWORD  dwSpMajorVersion,
	    __in  DWORD  dwSpMinorVersion,
	    __out PDWORD pdwReturnedProductType
	    );
	 */
	class Arg_GetProductInfo extends Arg_property {
		private int dwOSMajorVersion;
		private int dwOSMinorVersion;
		private int dwSpMajorVersion;
		private int dwSpMinorVersion;
		private int[] pdwReturnedProductType;

		Arg_GetProductInfo(int dwOSMajorVersion, int dwOSMinorVersion,
				int dwSpMajorVersion, int dwSpMinorVersion,
				int[] pdwReturnedProductType) {
			this.dwOSMajorVersion = dwOSMajorVersion;
			this.dwOSMinorVersion = dwOSMinorVersion;
			this.dwSpMajorVersion = dwSpMajorVersion;
			this.dwSpMinorVersion = dwSpMinorVersion;
			this.pdwReturnedProductType = pdwReturnedProductType;
		}
	}
	
	private boolean GetSystemMetrics(int nIndex) {
		Arg_GetSystemMetrics agsm = new Arg_GetSystemMetrics(nIndex);
		
		int intRtnVal = JInvoker.callIntProc("GetSystemMetrics", "user32", agsm);
		
		System.out.println("GetProcAddress rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(agsm.getLastError()));
		
		return intRtnVal != 0;
	}

	/*
	int GetSystemMetrics(
	  int nIndex   // VXegbN܂݂͌̍\
	);
	 */
	class Arg_GetSystemMetrics extends Arg_property {
		private int nIndex;

		Arg_GetSystemMetrics(int nIndex) {
			this.nIndex = nIndex;
		}
	}
	
	private final int NULL = 0;
	private final boolean TRUE = true;
	private final boolean FALSE = false;
	private final int SM_SERVERR2 = 89;
	private final int
		VER_PLATFORM_WIN32s			 = 0,
		VER_PLATFORM_WIN32_WINDOWS	 = 1,
		VER_PLATFORM_WIN32_NT		 = 2;
	private final int
		VER_NT_WORKSTATION			 = 0x0000001,
		VER_NT_DOMAIN_CONTROLLER	 = 0x0000002,
		VER_NT_SERVER				 = 0x0000003;
	private final int
		PRODUCT_ULTIMATE                        = 0x00000001,
		PRODUCT_HOME_BASIC                      = 0x00000002,
		PRODUCT_HOME_PREMIUM                    = 0x00000003,
		PRODUCT_ENTERPRISE                      = 0x00000004,
		PRODUCT_HOME_BASIC_N                    = 0x00000005,
		PRODUCT_BUSINESS                        = 0x00000006,
		PRODUCT_STANDARD_SERVER                 = 0x00000007,
		PRODUCT_DATACENTER_SERVER               = 0x00000008,
		PRODUCT_SMALLBUSINESS_SERVER            = 0x00000009,
		PRODUCT_ENTERPRISE_SERVER               = 0x0000000A,
		PRODUCT_STARTER                         = 0x0000000B,
		PRODUCT_DATACENTER_SERVER_CORE          = 0x0000000C,
		PRODUCT_STANDARD_SERVER_CORE            = 0x0000000D,
		PRODUCT_ENTERPRISE_SERVER_CORE          = 0x0000000E,
		PRODUCT_ENTERPRISE_SERVER_IA64          = 0x0000000F,
		PRODUCT_BUSINESS_N                      = 0x00000010,
		PRODUCT_WEB_SERVER                      = 0x00000011,
		PRODUCT_CLUSTER_SERVER                  = 0x00000012,
		PRODUCT_HOME_SERVER                     = 0x00000013,
		PRODUCT_STORAGE_EXPRESS_SERVER          = 0x00000014,
		PRODUCT_STORAGE_STANDARD_SERVER         = 0x00000015,
		PRODUCT_STORAGE_WORKGROUP_SERVER        = 0x00000016,
		PRODUCT_STORAGE_ENTERPRISE_SERVER       = 0x00000017,
		PRODUCT_SERVER_FOR_SMALLBUSINESS        = 0x00000018,
		PRODUCT_SMALLBUSINESS_SERVER_PREMIUM    = 0x00000019,
		PRODUCT_PROFESSIONAL				    = 0x00000030;
	private final int
		VER_SERVER_NT                       = 0x80000000,
		VER_WORKSTATION_NT                  = 0x40000000,
		VER_SUITE_SMALLBUSINESS             = 0x00000001,
		VER_SUITE_ENTERPRISE                = 0x00000002,
		VER_SUITE_BACKOFFICE                = 0x00000004,
		VER_SUITE_COMMUNICATIONS            = 0x00000008,
		VER_SUITE_TERMINAL                  = 0x00000010,
		VER_SUITE_SMALLBUSINESS_RESTRICTED  = 0x00000020,
		VER_SUITE_EMBEDDEDNT                = 0x00000040,
		VER_SUITE_DATACENTER                = 0x00000080,
		VER_SUITE_SINGLEUSERTS              = 0x00000100,
		VER_SUITE_PERSONAL                  = 0x00000200,
		VER_SUITE_BLADE                     = 0x00000400,
		VER_SUITE_EMBEDDED_RESTRICTED       = 0x00000800,
		VER_SUITE_SECURITY_APPLIANCE        = 0x00001000,
		VER_SUITE_STORAGE_SERVER            = 0x00002000,
		VER_SUITE_COMPUTE_SERVER            = 0x00004000,
		VER_SUITE_WH_SERVER		            = 0x00008000;
	private final int
		PROCESSOR_ARCHITECTURE_INTEL            = 0,
		PROCESSOR_ARCHITECTURE_MIPS             = 1,
		PROCESSOR_ARCHITECTURE_ALPHA            = 2,
		PROCESSOR_ARCHITECTURE_PPC              = 3,
		PROCESSOR_ARCHITECTURE_SHX              = 4,
		PROCESSOR_ARCHITECTURE_ARM              = 5,
		PROCESSOR_ARCHITECTURE_IA64             = 6,
		PROCESSOR_ARCHITECTURE_ALPHA64          = 7,
		PROCESSOR_ARCHITECTURE_MSIL             = 8,
		PROCESSOR_ARCHITECTURE_AMD64            = 9,
		PROCESSOR_ARCHITECTURE_IA32_ON_WIN64    = 10;
}
