package testw32apinew;
import utildll.*;

public class TestW32API25 {
	static final int CHARSET_SQLITE3 = Arg.UTF8;
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API25();
	}

	TestW32API25() {
	    final String strSQL[] = {
		    "DROP TABLE IF EXISTS sample;",
		    "CREATE TABLE sample ( i TEXT,  INTEGER );",
		    "INSERT INTO sample ( i,  ) VALUES ( 'ь', 100 );",
		    "INSERT INTO sample ( i,  ) VALUES ( '', 2000 );",
		    "INSERT INTO sample ( i,  ) VALUES ( '', 30000 );"
	    };
	    final String SQL_SELECT = "SELECT * FROM sample;";
	    int[] pArg = {0}; //R[obN֐R[
	    
		Sqlite3Wrp sw = new Sqlite3Wrp();
		for (int i = 0; i < strSQL.length; i++) {
			sw.exec(strSQL[i], null, null, null); 
		}
		sw.exec(SQL_SELECT,
				new Callback_def("callback_exec", Func.RTNTYPE_INT, 
						new Arg_sqlite3_callback(), this),
				pArg, null); 
		
		sw.close();
	}

	int callback_exec(Arg_sqlite3_callback asc) {
		asc.pArg[0]++;
		System.out.println("callback_exec#" + Integer.toString(asc.pArg[0]));
		
		for (int i = 0; i < asc.argc; i++) {
			System.out.println("column[" + Integer.toString(i) + "]: " + asc.column[i]
					+ " argv[" + Integer.toString(i) + "]: "  + asc.argv[i]);
		}
		
		return 0;
	}
	
	/*
	int sqlite3_callback(
		void *pArg,
		int argc,
		char **argv,
		char **column
	)
	 */
	@_CharSet(CHARSET_SQLITE3) @_Call(Arg.CDECL)
	class Arg_sqlite3_callback {
		private int[] pArg;
		private int argc;
		private @_Const @_Length_is("argc") String[] argv;
		private @_Const @_Length_is("argc") String[] column;
	}
	
	class Callback_def {
		private String _FuncName;
		private int _ReturnType;
		private Object _FuncArg;
		private Object _Instance;
		
		Callback_def(String _FuncName, int _ReturnType, Object _FuncArg, Object _Instance){
			this._FuncName = _FuncName;
			this._ReturnType = _ReturnType;
			this._FuncArg = _FuncArg;
			this._Instance = _Instance;
		}
	}

	class Sqlite3Wrp {
		private String[] strFncName = {"sqlite3_open_v2",
				"sqlite3_exec", "sqlite3_close"};
		private int[] intFncAdrs = new int[strFncName.length];
		private final int IDX_sqlite3_open_v2 = 0,
				IDX_sqlite3_exec = 1, IDX_sqlite3_close = 2;
		private int[] db = {0};
		private int hMod = 0;
		
		Sqlite3Wrp() {
			Arg_LoadLibrary all = new Arg_LoadLibrary("sqlite3");
			
			hMod = JInvoker.callIntProc("LoadLibrary", "kernel32", all);
			
			System.out.println("LoadLibrary rtn: " + Integer.toHexString(hMod)
					+ " LastError: " + Integer.toString(all.getLastError()));
			
			for (int i = 0; i < strFncName.length; i++) {
				Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
				
				intFncAdrs[i] = JInvoker.callIntProc("GetProcAddress", "kernel32", agpa);
				
				System.out.println("GetProcAddress rtn: " + Integer.toHexString(intFncAdrs[i])
						+ " LastError: " + Integer.toString(agpa.getLastError()));
			}
			
			Arg_sqlite3_open_v2 aso = new Arg_sqlite3_open_v2(
				DB_FILE_PATH, db, SQLITE_OPEN_CREATE | SQLITE_OPEN_READWRITE, null);
			
			int intRtn = JInvoker.callIntProcAddress(intFncAdrs[IDX_sqlite3_open_v2], aso);
			
			System.out.println("sqlite3_open_v2 rtn: " + Integer.toHexString(intRtn)
					+ " LastError: " + Integer.toString(aso.getLastError())
					+ " db: " + Integer.toHexString(db[0]));
		}
		
		final int SQLITE_OPEN_READWRITE = 0x2;
		final int SQLITE_OPEN_CREATE    = 0x4;
		final int SQLITE_OK    = 0x0;
		final String DB_FILE_PATH = ":memory:"; //C
	
		class Arg_property {
			private int _LastError;
		
			int getLastError() {return _LastError;}
		}

		@_CharSet(CHARSET_SQLITE3) @_Call(Arg.CDECL)
		class Arg_property_sqlite3 extends Arg_property {
		}

		/*
		SQLITE3_API int sqlite3_open_v2(
			const char *filename,   // Database filename (UTF-8)
			sqlite3 **ppDb,         // OUT: SQLite db handle
			int flags,              // Flags
			const char *zVfs        // Name of VFS module to use
		)
		 */
		class Arg_sqlite3_open_v2 extends Arg_property_sqlite3 {
			private @_Const String filename;
			private int[] ppDb;
			private int flags;
			private @_Const String zVfs;
	
			Arg_sqlite3_open_v2(String filename, int[] ppDb, int flags, String zVfs) {
				this.filename = filename;
				this.ppDb = ppDb;
				this.flags = flags;
				this.zVfs = zVfs;
			}
		}
		
		int exec(String zSql, Callback_def xCallback, int[] pArg, String[] pzErrMsg) {
			Arg_sqlite3_exec ase = new Arg_sqlite3_exec(
					db[0], zSql, xCallback, pArg, pzErrMsg);
			int intRtn = JInvoker.callIntProcAddress(intFncAdrs[IDX_sqlite3_exec], ase);
			
			System.out.println("sqlite3_exec rtn: " + Integer.toHexString(intRtn)
					+ " LastError: " + Integer.toString(ase.getLastError()));
			
			return intRtn;
		}

		/*
		SQLITE3_API int sqlite3_exec(
			sqlite3 *db,                // The database on which the SQL executes
			const char *zSql,           // The SQL to be executed
			sqlite3_callback xCallback, // Invoke this callback routine
			void *pArg,                 // First argument to xCallback()
			char **pzErrMsg             // Write error messages here
		)
		 */
		class Arg_sqlite3_exec extends Arg_property_sqlite3 {
			private int db;
			private @_Const String zSql;
			private @_FuncPtr Callback_def xCallback;
			private int[] pArg;
			private String[] pzErrMsg;
	
			Arg_sqlite3_exec(int db, String zSql, Callback_def xCallback, int[] pArg, String[] pzErrMsg) {
				this.db = db;
				this.zSql = zSql;
				this.xCallback = xCallback;
				this.pArg = pArg;
				this.pzErrMsg = pzErrMsg;
			}
		}
		
		int close() {
			Arg_sqlite3_close asc = new Arg_sqlite3_close(db[0]);
			
			int intRtn = JInvoker.callIntProcAddress(intFncAdrs[IDX_sqlite3_close], asc);
			
			System.out.println("sqlite3_close rtn: " + Integer.toHexString(intRtn)
					+ " LastError: " + Integer.toString(asc.getLastError()));
			
			Arg_FreeLibrary afl = new Arg_FreeLibrary(hMod);

			boolean blRtn = JInvoker.callBooleanProc("FreeLibrary", "kernel32", afl);
			
			System.out.println("FreeLibrary rtn: " + Boolean.toString(blRtn)
					+ " LastError: " + Integer.toString(afl.getLastError()));

			return intRtn;
		}
		/*
		SQLITE3_API int sqlite3_close(
			sqlite3 *db
		)
		 */
		class Arg_sqlite3_close extends Arg_property_sqlite3 {
			private int db;
			
			Arg_sqlite3_close(int db) {
				this.db = db;
			}
		}
		
		/*
		HMODULE LoadLibrary(
		  LPCTSTR lpFileName   // W[̃t@C
		);
		 */
		@_CharSet(CHARSET)
		class Arg_LoadLibrary extends Arg_property {
			private @_Const String lpFileName;
	
			Arg_LoadLibrary(String lpFileName) {
				this.lpFileName = lpFileName;
			}
		}
		
		/*
		FARPROC GetProcAddress(
		  HMODULE hModule,    // DLL W[̃nh
		  LPCSTR lpProcName   // ֐
		);
		 */
		@_CharSet(Arg.ANSI)
		class Arg_GetProcAddress extends Arg_property {
			private int hModule;
			private @_Const @_Ansi String lpProcName;
	
			Arg_GetProcAddress(int hModule, String lpProcName) {
				this.hModule = hModule;
				this.lpProcName = lpProcName;
			}
		}
		
		/*
		BOOL FreeLibrary(
			HMODULE hModule   // DLL W[̃nh
		);
		 */
		class Arg_FreeLibrary extends Arg_property {
			private int hModule;
	
			Arg_FreeLibrary(int hModule) {
				this.hModule = hModule;
			}
		}
	}
}
